// This aspect does not depend on any config file.
// This files contain such generic aspects.
public aspect YTraceNameThreadAspect {
	
	// Get a fully qualified name of the thread
	pointcut startThread() : call(void Thread.start(..));
	
	before(Thread t): startThread() && target(t) {
		String threadName =  t.getName() + "@" + YTraceLoggerUtilities.getPID();
		t.setName(threadName);
		//System.out.println(t.getName());
	}
	
	// Get a fully qualified name of the main thread if there is any
	pointcut main(): execution(void *.main(..));
	
	before(): main() {
		Thread t = Thread.currentThread();
		String threadName =  t.getName() + "@" + YTraceLoggerUtilities.getPID();
		t.setName(threadName);
		//System.out.println(t.getName());
	}
}